package edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnNameList;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.*;

/**
 * An interface for the NameColumn opertor.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0      
 */
public interface NameColumn extends SpecialOperator {
    /**
     * Extends the semantic of NameColumn operator.
     * It also used to identify a start of a new query block.
     * This will give back query block description.
     * So far, we have one meaningful desc: "return".
     * Which is used to tell the decore engine to put the LOJ
     * below that operator.
     * @return java.lang.String
     * @since   1.0          
     */
    String getBlockDesc();

    /**
     * Insert the method's description here.
     * @return edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavigationStep[]
     * @since   1.0          
     */
    NavigationStep[] getColumnPath();
    String getNewColumnName();
    String getOriginalColumnName();

    /**
     * Set block description.
     * @param desc java.lang.String
     * @since   1.0          
     * @see getBlockDesc()
     */
    void setBlockDesc(String desc);

    /**
     * Sets column path.
     * @param param edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavigationStep
     * @since   1.0          
     */
    void setColumnPath(NavigationStep[] param);

    /**
     * Sets new column name.
     * @param new_name is the new column name
     * @since   1.0          
     */
    void setNewColumnName(String new_name);

    /**
     * Sets original column name.
     * @param original_name is the original column name
     * @since   1.0          
     */
    void setOriginalColumnName(String original_name);
}