package edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
/**
 * The Function interface.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
 */

public interface Function extends SpecialOperator {
    /**
     * Execution method.
     * @param deRefParamV are the parameters    
     * @since   1.0      
     */
    void execute();

    /**
     * Get the name of this function.
     * @return the Name of this Function.
     * @since   1.0      
     */
    String getName();

    /**
     * It returns all the parameters in an array.
     * @return The parameters.
     * @since   1.0           
     */
    Object[] getParams();

    /**
     * Get all the sources of this function.
     * @return XATTable of all the sources of this function.
     * @since   1.0           
     */
    XATTable[] getSources();

    /**
     * Set the function name.
     * @param new_name the functine name.      
     * @since   1.0          
    */
    void setName(String new_name);

    /**
     * Set the new parameters of this function.
     * @param newParams the function parameter.     
     * @return original parameters.
     * @since   1.0               
     */
    Object[] setParams(Object[] newParams);
}