package edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnNameList;

/**
 * It will create groups for each unique value of the groupby columns.
 * and for each group, it will apply the subquery to it.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
 */
public interface GroupBy extends SQLOperator, ColumnNameList {
    /** 
     * Returns a list of column names. 
     * @return an array of column names.
     * @since   1.0     
     */
    String[] getColumnNames();

    /** 
     * Gets a the XAT tree associtaed with this GroupBy (the groupby subquery). 
     * @return the GroupBy XAT tree
     * @since   1.0         
    */
    XATTree getXATTree();

    /**
     * Set the list of column names to be grouped based on.
     * @param columns is the list of column names to be grouped based on
     * @since   1.0            
     */
    void setColumnNames(String[] columns);

    /** 
     * Set the groupby XAT tree (subquery). 
     * @param newXAT is the groupby XAT tree
     * @since   1.0                
    */
    XATTree setXATTree(XATTree newXAT);
}