package edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern;

/**
 * The visitor provide the additional functionality to an existing data structure. This data structure should
 * be open enough to make the visitor make the job down. <p>
 * Usually, the Visitable class should provide public methods to access its data.
 */
public interface Visitor
{
    /**
     * In the visit() function, you don't need to provide any kind of traversal strategy. That should be provided by the
     * accept() function in the Visitable classes. <p> It will only provide the additional functionality except
     * the traversing provided by the accept() function. <p> The visit function should NEVER call obj.accept()!!!! Because
     * that interfere with the traverse strategy in the obj.accept(). <p>
     * If there is an inheritance between the visited objects, it will only match the highest class.
     * @return Object 
     * @param object The object visited.
     * @since 1.0
     */
    Object visit(Object object);
}
