package edu.wpi.cs.dsrg.xmldb.xat.testfiles;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////
import java.util.*;
import java.io.*;
import xacute.quilt.*;

import edu.wpi.cs.dsrg.utils.*;
import edu.wpi.cs.dsrg.utils.ObjectPrinter;
import edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.querymerger.*;
import edu.wpi.cs.dsrg.xmldb.xat.testfiles.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.schemacleanup.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.operatorexec.ExecuteVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.component.xattreegeneration.*;

/**
 * This Class is used to test operators.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0
 */

public class TestOperators {

  public static boolean withSchema = false;
  public static boolean decorrelate = false;
  public static boolean pushdown = false;

  public static boolean DEBUG = false;

/**
 * createMenu
 */
public static void createMenu(String[] args) {
    String input = "";
    // Input read from the user to specify and conditional xml file
    String inputUser = "";
    // Input read from the user to specify and conditional xml file
    String inputView = "";
    // Input read from the user to specify and conditional xml file
    if (args.length < 1) {
        BufferedReader in1 = new BufferedReader(new InputStreamReader(System.in));
        // The buffer used to pass to the input string

        System.out.print("Please enter in the operator you would like to test: ");

        // Check for a valid operator and call the appropriate subroutine or exit the program
        // If an xml file is required, then the user will be prompted for the name of the xml file to be
        // used for that specific operator.

        try {
            input = in1.readLine();
        } catch (IOException e) {
            System.out.println("Unable to read the user input");
        }
        System.out.println("");
    } else {
        input = args[0];
    }
    if (input.toLowerCase().equals("function")) {
        testFunctions();
    } else
        if (input.toLowerCase().equals("groupby")) {
            testGroupBy();
        } else
            if (input.toLowerCase().equals("intersection")) {
                testIntersection();
            } else
                if (input.toLowerCase().equals("navigate")) {
                    System.out.print("For Navigate, please specify the xml file: ");
                    BufferedReader in1 = new BufferedReader(new InputStreamReader(System.in));
                    try {
                        input = in1.readLine();
                        testNavigate(input);
                    } catch (IOException e) {
                        System.out.println("Unable to read the user input");
                        System.exit(1);
                    } catch (XATNodeDoesNotExistException e) {
                    }
                } else
                    if (input.toLowerCase().equals("orderby")) {
                        testOrderBy();
                    } else
                        if (input.toLowerCase().equals("project")) {
                            testProject();
                        } else
                            if (input.toLowerCase().equals("select")) {
                                testSelect();
                            } else
                                if (input.toLowerCase().equals("thetajoin")) {
                                    testThetaJoin();
                                } else
                                    if (input.toLowerCase().equals("expose")) {
                                        System.out.print("For expose, please specify the xml file: ");
                                        BufferedReader in1 = new BufferedReader(new InputStreamReader(System.in));
                                        try {
                                            input = in1.readLine();
                                            testXMLExpose(input);
                                        } catch (IOException e) {
                                            System.out.println("Unable to read the user input");
                                            System.exit(1);
                                        }
                                    } else
                                        if (input.toLowerCase().equals("leftouter")) {
                                            testLeftOuterJoin();
                                        } else
                                            if (input.toLowerCase().equals("leftsemi")) {
                                                testLeftSemiJoin();
                                            } else
                                                if (input.toLowerCase().equals("rightouter")) {
                                                    testRightOuterJoin();
                                                } else
                                                    if (input.toLowerCase().equals("rightsemi")) {
                                                        testRightSemiJoin();
                                                    } else
                                                        if (input.toLowerCase().equals("outerunion")) {
                                                            testOuterUnion();
                                                        } else
                                                            if (input.toLowerCase().equals("xmlunion")) {
                                                                testXMLUnion();
                                                            } else
                                                            if (input.toLowerCase().equals("xmldifference")) {
                                                                testXMLDifference();
                                                            } else
                                                            if (input.toLowerCase().equals("xmlintersection")) {
                                                                testXMLIntersection();
                                                            }else
                                                                if (input.toLowerCase().equals("merge")) {
                                                                    testMerge();
                                                                } else
                                                                if (input.toLowerCase().equals("difference")) {
                                                                    testDifference();
                                                                }else
                                                                    if (input.toLowerCase().equals("union")) {
                                                                        testUnion();
                                                                    } else
                                                                        if (input.toLowerCase().equals("for")) {
                                                                            testFor();
                                                                        } else
                                                                            if (input.toLowerCase().equals("sqlstmt")) {
                                                                                testSQLStmt();
                                                                            } else
                                                                                if (input.toLowerCase().equals("composer")) {
                                                                                    testComposer();
                                                                                } else
                                                                                    if (input.toLowerCase().equals("xmlunion")) {
                                                                                        testXMLUnion();
                                                                                    } else
                                                                                        if (input.toLowerCase().equals("tree2")) {
                                                                                            if (args.length < 2) {
                                                                                                System.out.print("For Tree Generation, please specify the qlt file: ");
                                                                                                BufferedReader in1 = new BufferedReader(new InputStreamReader(System.in));
                                                                                                try {
                                                                                                    input = in1.readLine();
                                                                                                } catch (IOException e) {
                                                                                                    System.out.println("Unable to read the user input");
                                                                                                    System.exit(1);
                                                                                                }
                                                                                            } else {
                                                                                                inputUser = args[1];
                                                                                                inputView = args[2];

                                                                                            }
                                                                                            for (int i = 3; i < args.length; i++) {
                                                                                                if (args[i].equals("schema")) {
                                                                                                    withSchema = !withSchema;
                                                                                                } else
                                                                                                    if (args[i].equals("pushdown")) {
                                                                                                        pushdown = !pushdown;
                                                                                                    } else
                                                                                                        if (args[i].equals("debug")) {
                                                                                                            DEBUG = true;
                                                                                                        }
                                                                                            }
                                                                                            testTree(inputUser, inputView);
                                                                                        } else
                                                                                            if (input.toLowerCase().equals("tree1")) {
                                                                                                if (args.length < 2) {
                                                                                                    System.out.print("For Tree Generation, please specify the qlt file: ");
                                                                                                    BufferedReader in1 = new BufferedReader(new InputStreamReader(System.in));
                                                                                                    try {
                                                                                                        input = in1.readLine();
                                                                                                    } catch (IOException e) {
                                                                                                        System.out.println("Unable to read the user input");
                                                                                                        System.exit(1);
                                                                                                    }
                                                                                                } else {
                                                                                                    inputUser = args[1];

                                                                                                }
                                                                                                for (int i = 2; i < args.length; i++) {
                                                                                                    if (args[i].equals("schema")) {
                                                                                                        withSchema = !withSchema;
                                                                                                    } else
                                                                                                        if (args[i].equals("pushdown")) {
                                                                                                            pushdown = !pushdown;
                                                                                                        } else
                                                                                                            if (args[i].equals("debug")) {
                                                                                                                DEBUG = true;
                                                                                                            }
                                                                                                }
                                                                                                testTree(inputUser);
                                                                                            } else {
                                                                                                System.out.println("Sorry, that is not a valid operator");
                                                                                                System.out.println("The valid options are as follows: ");
                                                                                                System.out.println(
                                                                                                    " GroupBy\n Intersect\n Navigate\n OrderBy\n Project\n Select\n ThetaJoin\n Expose\n"
                                                                                                        + " RightOuter\n RightSemi\n LeftOuter\n LeftSemi\n OuterUnion\n Union\n For");

                                                                                            }

}
  // args:
  public static void main(String[] args)
  {
      // Creates the menu for testing
      createMenu(args);
  }
    /**
     * Reads in the contents of a file and converts it to a string object
     */
    private static String readQuery(String file)
	throws Exception
    {
	BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
	StringBuffer buf = new StringBuffer();
	String s;
	while ( (s=in.readLine()) != null)
	    buf.append(s + "\n");
        in.close();
	return buf.toString();
    }
  /**
   * testComposer
   */
  public static void testComposer()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabTest = new XATTableImp();
    xtabTest.setName("Luping's Test");
    XATTree xtreeTest = new XATTreeImp();

    Vector vInputCol = new Vector();
    vInputCol.add(new String("1"));
    vInputCol.add(new String("1"));
    vInputCol.add(new String("1"));
    vInputCol.add(new String("1"));
    vInputCol.add(new String("1"));
    try
    {
      xtabTest.appendColumn("id1", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}
    
    vInputCol.clear();
    vInputCol.add(new String(""));
    vInputCol.add(new String("2"));
    vInputCol.add(new String("2"));
    vInputCol.add(new String("2"));
    vInputCol.add(new String("2"));
    try
    {
      xtabTest.appendColumn("id2", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    vInputCol.clear();
    vInputCol.add(new String(""));
    vInputCol.add(new String(""));
    vInputCol.add(new String("3"));
    vInputCol.add(new String("4"));
    vInputCol.add(new String("5"));
    try
    {
      xtabTest.appendColumn("id3", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    vInputCol.clear();
    vInputCol.add(new String("prices"));
    vInputCol.add(new String("book"));
    vInputCol.add(new String("title"));
    vInputCol.add(new String("source"));
    vInputCol.add(new String("price"));
    try
    {
      xtabTest.appendColumn("type", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    vInputCol.clear();
    vInputCol.add(new String(""));
    vInputCol.add(new String(""));
    vInputCol.add(new String("TCP/IP Illustrated"));
    vInputCol.add(new String("www.amazon.com"));
    vInputCol.add(new String("65.95"));
    try
    {
      xtabTest.appendColumn("value", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}
     

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    Composer comp = new ComposerImp(xnRootNode, 3);
    xnRootNode.setOperator(comp);

    XATNode xnsourceNode = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest = new SourceImp(xnsourceNode);
    xnsourceNode.setOperator(srTest);


    XATNode[] xLeaves = xtreeTest.getLeaves();
    for(int i = 0; i<xLeaves.length; i++)
    {
	((Source)xLeaves[i].getOperator()).setOutput(xtabTest);
	((Source)xLeaves[i].getOperator()).setType(Source.TABLE);
    }
    // end setup
    if (withSchema)
    {
      SchemaCleanupVisitor sc = new SchemaCleanupVisitor();
      sc.visit(xtreeTest);
    }


    System.out.println("Table before composing");
    System.out.println(xtabTest);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

  }
/**
 * testDifference
 */
  public static void testDifference()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    XATTable xtabITest2 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();

	Vector testV = new Vector();
	testV.add(new Integer(12));
	testV.add(new Integer(11));
    
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(testV);
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    vInputCol.add(new Integer(10));
    
    Vector vInputCol3 = new Vector();
    vInputCol3.add(new Integer(15));
    vInputCol3.add(new Integer(6));
    vInputCol3.add(new Integer(11));
    vInputCol3.add(new Integer(4));
    vInputCol3.add(new Integer(11));
    vInputCol3.add(new Integer(2));
    vInputCol3.add(new Integer(9));
    vInputCol3.add(new Integer(10));

    Vector vInputCol5 = new Vector();
    vInputCol5.add(new Integer(7));
    vInputCol5.add(new Integer(6));
    vInputCol5.add(new Integer(5));
    vInputCol5.add(new Integer(4));
    vInputCol5.add(new Integer(11));
    vInputCol5.add(new Integer(2));
    vInputCol5.add(new Integer(9));
	vInputCol5.add(new Integer(10));

    
    xtabITest1.setName("Test1");
    try
    {
		xtabITest1.appendColumn("Column11", vInputCol);
		xtabITest1.appendColumn("Column13", vInputCol3);
		xtabITest1.appendColumn("Column14", vInputCol5);
    }

    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(26));
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(13));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));
    
    Vector vInputCol4 = new Vector();
    vInputCol4.add(new Integer(26));
    vInputCol4.add(new Integer(15));
    vInputCol4.add(new Integer(2));
    vInputCol4.add(new Integer(11));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(34));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(9));
    
    Vector vInputCol6 = new Vector();
    vInputCol6.add(new Integer(26));
    vInputCol6.add(new Integer(15));
    vInputCol6.add(new Integer(2));
    vInputCol6.add(testV);
    vInputCol6.add(new Integer(9));
    vInputCol6.add(new Integer(34));
    vInputCol6.add(new Integer(9));
    vInputCol6.add(new Integer(4));
    
    xtabITest2.setName("Test2");
    try
    {
      xtabITest2.appendColumn("Column11", vInputCol6);
      xtabITest2.appendColumn("Column13", vInputCol4);
      xtabITest2.appendColumn("Column14", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    Difference ou = new DifferenceImp(xnRootNode);
    xnRootNode.setOperator(ou);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode2 = xnRootNode.getChild(1);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

	((Source)xLeaves[1].getOperator()).setOutput(xtabITest2);
	((Source)xLeaves[1].getOperator()).setType(Source.TABLE);
    // end setup


    System.out.println("TestDifference");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the Difference");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
  /**
   * testFor
   */

  public static void testFor()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabForTest = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    xtabForTest.setName("Greg's Test");
    try
    {
      xtabForTest.appendColumn("Column1", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(3));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(1));
    try
    {
      xtabForTest.appendColumn("Column2", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}



    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    FORImp fr = new FORImp(xnRootNode);
    String[] saGroupCols = {"Column1", "Column2"};
    fr.setColumnNames(saGroupCols);

        // create test expressions
    TerminalExpression expLeft = new  TerminalExpressionImp(new ColumnNameImp("Greg's Test", "Column1"));
    TerminalExpression expRight = new  TerminalExpressionImp(3);

    BinCOMPExpression TestExpression = new BinCOMPExpressionImp(expLeft, expRight);
    TestExpression.setType(BinCOMPExpression.GEQ);
    /////

    XATTree testTree = new XATTreeImp();
    // create XATNode.
    XATNode SelectNode = new XATNodeImp();
    // make the funNode as the root.
    testTree.setRoot(SelectNode);
    // fill the funNode;
    Select s = new SelectImp(SelectNode, TestExpression);
    SelectNode.setOperator(s);

    fr.setXtreFunctions(testTree);
    xnRootNode.setOperator(fr);


    XATNode xnsourceNode = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest = new SourceImp(xnsourceNode);
    xnsourceNode.setOperator(srTest);


    XATNode[] xLeaves = xtreeTest.getLeaves();
    for(int i = 0; i<xLeaves.length; i++)
    {
      ((Source)xLeaves[i].getOperator()).setOutput(xtabForTest);
      ((Source)xLeaves[i].getOperator()).setType(Source.TABLE);
    }
    // end setup


    System.out.println("TestFor");
    System.out.println("Table before sort");
    System.out.println(xtabForTest);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the For run on [Column2, Column1]");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
  /**
   * testFunctions
   */
  public static void testFunctions()
  {
  	    // create an XATTree with two nodes.
	    XATTree testTree = new XATTreeImp();

	    // create an source XATNode.
	    XATNode srcNode = new XATNodeImp();

	    // create a test Table.
	    XATTable testTable = new XATTableImp();
	    testTable.setName("test");
	    Vector column = new Vector();
	    column.addElement("100");
	    column.addElement("20");
	    try{
		    testTable.appendColumn("col1", column);
	    }catch(Exception e){
		    e.printStackTrace();
	    }

	    System.out.println("Test Table: "  + testTable);

		// create a source operator.
		Source srcOp = new SourceImp(srcNode);
		srcNode.setOperator(srcOp);
	    // set it's output table.
		srcOp.setOutput(testTable);

	    // create second XATNode.
	    XATNode funNode = new XATNodeImp();

	    // make the funNode as the root.
	    testTree.setRoot(funNode);

	    // make testNode as child of funNode.
	    funNode.addChild(srcNode);

	    // fill the funNode;
        Function f = new FunctionImp(funNode);
        funNode.setOperator(f);
        f.setName("MIN");
        f.setParams(new String[] { "col1" });


        // try it!
        System.out.println("TestFunctions");
        System.out.println("begin executing functions");
        f.execute();
        System.out.println("end executing functions");

        System.out.println("This is the output of the Function");
        System.out.println(f.getOutput());
  }
  /**
   * testGroupBy
   */

  public static void testGroupBy()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabGBTest = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    xtabGBTest.setName("Greg's Test");
    try
    {
      xtabGBTest.appendColumn("Column1", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(3));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(1));
    try
    {
      xtabGBTest.appendColumn("Column2", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}



    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    GroupBy gb = new GroupByImp(xnRootNode);
    String[] saGroupCols = {"Column1", "Column2"};
    gb.setColumnNames(saGroupCols);

    /*
    XATTree testTree = new XATTreeImp();
    // create XATNode.
    XATNode funNode = new XATNodeImp();
    // make the funNode as the root.
    testTree.setRoot(funNode);
    // fill the funNode;
    Function f = new FunctionImp(funNode);
    funNode.setOperator(f);
    f.setName("COUNT");
    // f.setParams( new Object[]{new ColumnNameImp("Column1"), new String( "1") });
    f.setParams(new String[] { "Column1" });
    gb.setXATTree(testTree);
    xnRootNode.setOperator(gb);
    */

        // create test expressions
    /////
    TerminalExpression expLeft = new  TerminalExpressionImp(new ColumnNameImp("Greg's Test", "Column1"));
    TerminalExpression expRight = new  TerminalExpressionImp(3);

    BinCOMPExpression TestExpression = new BinCOMPExpressionImp(expLeft, expRight);
    TestExpression.setType(BinCOMPExpression.GEQ);
    /////

    XATTree testTree = new XATTreeImp();
    // create XATNode.
    XATNode SelectNode = new XATNodeImp();
    // make the funNode as the root.
    testTree.setRoot(SelectNode);
    // fill the funNode;
    Select s = new SelectImp(SelectNode, TestExpression);
    SelectNode.setOperator(s);

    gb.setXATTree(testTree);
    xnRootNode.setOperator(gb);


    XATNode xnsourceNode = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest = new SourceImp(xnsourceNode);
    xnsourceNode.setOperator(srTest);


    XATNode[] xLeaves = xtreeTest.getLeaves();
    for(int i = 0; i<xLeaves.length; i++)
    {
      ((Source)xLeaves[i].getOperator()).setOutput(xtabGBTest);
      ((Source)xLeaves[i].getOperator()).setType(Source.TABLE);
    }
    // end setup


    System.out.println("TestGroupBy");
    System.out.println("Table before sort");
    System.out.println(xtabGBTest);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the GroupBy is run on [Column2, Column1]");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testIntersection
 */
  public static void testIntersection()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    XATTable xtabITest2 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();

	Vector testV = new Vector();
	testV.add(new Integer(12));
	testV.add(new Integer(11));
    
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(testV);
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    vInputCol.add(new Integer(10));
    
    Vector vInputCol3 = new Vector();
    vInputCol3.add(new Integer(15));
    vInputCol3.add(new Integer(6));
    vInputCol3.add(new Integer(11));
    vInputCol3.add(new Integer(4));
    vInputCol3.add(new Integer(11));
    vInputCol3.add(new Integer(2));
    vInputCol3.add(new Integer(9));
    vInputCol3.add(new Integer(10));

    Vector vInputCol5 = new Vector();
    vInputCol5.add(new Integer(7));
    vInputCol5.add(new Integer(6));
    vInputCol5.add(new Integer(5));
    vInputCol5.add(new Integer(4));
    vInputCol5.add(new Integer(11));
    vInputCol5.add(new Integer(2));
    vInputCol5.add(new Integer(9));
	vInputCol5.add(new Integer(10));

    
    xtabITest1.setName("Test1");
    try
    {
		xtabITest1.appendColumn("Column11", vInputCol);
		xtabITest1.appendColumn("Column13", vInputCol3);
		xtabITest1.appendColumn("Column14", vInputCol5);
    }

    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(26));
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(13));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));
    
    Vector vInputCol4 = new Vector();
    vInputCol4.add(new Integer(26));
    vInputCol4.add(new Integer(15));
    vInputCol4.add(new Integer(2));
    vInputCol4.add(new Integer(11));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(34));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(9));
    
    Vector vInputCol6 = new Vector();
    vInputCol6.add(new Integer(26));
    vInputCol6.add(new Integer(15));
    vInputCol6.add(new Integer(2));
    vInputCol6.add(testV);
    vInputCol6.add(new Integer(9));
    vInputCol6.add(new Integer(34));
    vInputCol6.add(new Integer(9));
    vInputCol6.add(new Integer(4));
    
    xtabITest2.setName("Test2");
    try
    {
      xtabITest2.appendColumn("Column11", vInputCol6);
      xtabITest2.appendColumn("Column13", vInputCol4);
      xtabITest2.appendColumn("Column14", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    Intersection ou = new IntersectionImp(xnRootNode);
    xnRootNode.setOperator(ou);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode2 = xnRootNode.getChild(1);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

	((Source)xLeaves[1].getOperator()).setOutput(xtabITest2);
	((Source)xLeaves[1].getOperator()).setType(Source.TABLE);
    // end setup


    System.out.println("TestIntersection");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the Intersection");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testLeftOuterJoin
 */
public static void testLeftOuterJoin() {
    ExecuteVisitor execTest = new ExecuteVisitor();

    // begin setup

    // make two columns.
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));

    // make first table.
    XATTable xtabITest1 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();

    xtabITest1.setName("Test1");
    try {
        xtabITest1.appendColumn("Column10", vInputCol2);
        xtabITest1.appendColumn("Column11", vInputCol);
        xtabITest1.appendColumn("Column13", vInputCol2);
    } catch (XATTableTupleNoMatchException e) {
    }

    // make the second table. 
    XATTable xtabITest2 = new XATTableImp();
    xtabITest2.setName("Test2");
    try {
        xtabITest2.appendColumn("Column11", vInputCol2);
        xtabITest2.appendColumn("Column12", vInputCol);
        xtabITest2.appendColumn("Column14", vInputCol);
    } catch (XATTableTupleNoMatchException e) {
    }

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    LeftOuterJoin loj = new LeftOuterJoinImp(xnRootNode, null);
    xnRootNode.setOperator(loj);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try {
        xnsourceNode1 = xnRootNode.getChild(0);
    } catch (XATNodeDoesNotExistException e) {
    }

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);

    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try {
        xnsourceNode2 = xnRootNode.getChild(1);
    } catch (XATNodeDoesNotExistException e) {
    }

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);

    XATNode[] xLeaves = xtreeTest.getLeaves();
    ((Source) xLeaves[0].getOperator()).setOutput(xtabITest1);
    ((Source) xLeaves[0].getOperator()).setType(Source.TEMP);

    ((Source) xLeaves[1].getOperator()).setOutput(xtabITest2);
    ((Source) xLeaves[1].getOperator()).setType(Source.TEMP);
    // end setup

    System.out.println("TestLeftOuterJoin");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println(
        "This is the output of the LeftOuterJoin for Column11=Column12");
    System.out.println(xtreeTest.getRoot().getOperator().getOutputDataSource());
}
/**
 * testLeftSemiJoin
 */
  public static void testLeftSemiJoin()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    XATTable xtabITest2 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(21));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    xtabITest1.setName("Test1");
    try
    {
      xtabITest1.appendColumn("Column11", vInputCol);
    }

    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));
    xtabITest2.setName("Test2");
    try
    {
      xtabITest2.appendColumn("Column12", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    // create test expressions
    /////
    TerminalExpression expLeft = new  TerminalExpressionImp(new ColumnNameImp("Test1", "Column11"));
    TerminalExpression expRight = new  TerminalExpressionImp(new ColumnNameImp("Test2", "Column12"));

    BinCOMPExpression TestExpression = new BinCOMPExpressionImp(expLeft, expRight);
    TestExpression.setType(BinCOMPExpression.EQ);
    /////

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    LeftSemiJoin lsj = new LeftSemiJoinImp(xnRootNode, TestExpression);
    xnRootNode.setOperator(lsj);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode2 = xnRootNode.getChild(1);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

	((Source)xLeaves[1].getOperator()).setOutput(xtabITest2);
	((Source)xLeaves[1].getOperator()).setType(Source.TABLE);
    // end setup


    System.out.println("TestLeftSemiJoin");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the LeftSemiJoin for Column11=Column12");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testOuterUnion
 */
  public static void testMerge()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    XATTable xtabITest2 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    
    vInputCol.add(new Integer(10));
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    
    Vector vInputCol3 = new Vector();
    vInputCol3.add(new Integer(10));
    vInputCol3.add(new Integer(15));
    vInputCol3.add(new Integer(6));
    vInputCol3.add(new Integer(5));
    vInputCol3.add(new Integer(4));
    vInputCol3.add(new Integer(11));
    vInputCol3.add(new Integer(2));
    vInputCol3.add(new Integer(9));

    Vector vInputCol5 = new Vector();
    vInputCol5.add(new Integer(10));
    vInputCol5.add(new Integer(7));
    vInputCol5.add(new Integer(6));
    vInputCol5.add(new Integer(5));
    vInputCol5.add(new Integer(4));
    vInputCol5.add(new Integer(11));
    vInputCol5.add(new Integer(2));
    vInputCol5.add(new Integer(9));


    
    xtabITest1.setName("Test1");
    try
    {
		xtabITest1.appendColumn("Column11", vInputCol);
		xtabITest1.appendColumn("Column13", vInputCol3);
		xtabITest1.appendColumn("Column14", vInputCol5);
    }

    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(26));
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(13));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));
    
    Vector vInputCol4 = new Vector();
    vInputCol4.add(new Integer(26));
    vInputCol4.add(new Integer(15));
    vInputCol4.add(new Integer(2));
    vInputCol4.add(new Integer(11));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(34));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(9));
    
    Vector vInputCol6 = new Vector();
    vInputCol6.add(new Integer(26));
    vInputCol6.add(new Integer(15));
    vInputCol6.add(new Integer(2));
    vInputCol6.add(new Integer(11));
    vInputCol6.add(new Integer(9));
    vInputCol6.add(new Integer(34));
    vInputCol6.add(new Integer(9));
    vInputCol6.add(new Integer(4));
    
    xtabITest2.setName("Test2");
    try
    {
      xtabITest2.appendColumn("Column5", vInputCol6);
      xtabITest2.appendColumn("Column6", vInputCol4);
      xtabITest2.appendColumn("Column7", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    Merge ou = new MergeImp(xnRootNode);
    xnRootNode.setOperator(ou);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode2 = xnRootNode.getChild(1);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

	((Source)xLeaves[1].getOperator()).setOutput(xtabITest2);
	((Source)xLeaves[1].getOperator()).setType(Source.TABLE);
    // end setup


    System.out.println("TestMerge");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the Merge");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testNavigate
 */
  public static void testNavigate(String sXMLFile) throws XATNodeDoesNotExistException
  {

    ExecuteVisitor execTest = new ExecuteVisitor();
    // start setup
    XATTree tree1;
    // create a very small tree.
    System.out.println("Creating tree");
    tree1 = new XATTreeImp();


    // adding the first child
    tree1.setRoot(new XATNodeImp());
    Navigate nvNav = new NavUnnestImp(tree1.getRoot());

    // setting the root node
//    tree1.setRoot();
    tree1.getRoot().setOperator(nvNav);
    nvNav.setBinding("col1");
    NavigationStep[] nsEntry = { new VarStepImp("R1")};
    NavigationStep[] nsDestination = { new NodeStepImp("/book"),  new NodeStepImp("@title"), new NodeStepImp("/text()")};
    nvNav.setEntryPoint(nsEntry);
    nvNav.setDestination(nsDestination);

    // adding second child
    tree1.addNode(new XATNodeImp(),tree1.getRoot());
    Source sSource = new SourceImp(tree1.getRoot().getChild(0), sXMLFile, Source.XML);
    sSource.setOutputColumnName("R1");
    tree1.getRoot().getChild(0).setOperator(sSource);
    // end setup
    if (withSchema)
    {
      SchemaCleanupVisitor sc = new SchemaCleanupVisitor();
      sc.visit(tree1);
    }

    System.out.println("TestNavigate");
    System.out.println("begin executing Operator");
    execTest.visit(tree1);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the Navigate Operator");
    System.out.println(nvNav.getOutput());
  }
  /**
   * testOrderBy
   */
  public static void testOrderBy()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabOBTest = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(1));
    vInputCol.add(new Integer(5));
    vInputCol.add(new Integer(7));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(4));
    vInputCol.add(new Integer(19));
    vInputCol.add(new Integer(6));
    xtabOBTest.setName("Greg's Test");
    try
    {
      xtabOBTest.appendColumn("Column1", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(1));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(3));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(7));
    try
    {
      xtabOBTest.appendColumn("Column2", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}



    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    OrderBy ob = new OrderByImp(xnRootNode);
    String[] saOrderCols = {"Column1"};
    ob.setColumnNames(saOrderCols);
    xnRootNode.setOperator(ob);

    XATNode xnsourceNode = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest = new SourceImp(xnsourceNode);
    xnsourceNode.setOperator(srTest);


    XATNode[] xLeaves = xtreeTest.getLeaves();
    for(int i = 0; i<xLeaves.length; i++)
    {
	((Source)xLeaves[i].getOperator()).setOutput(xtabOBTest);
	((Source)xLeaves[i].getOperator()).setType(Source.TABLE);
    }
    // end setup
    if (withSchema)
    {
      SchemaCleanupVisitor sc = new SchemaCleanupVisitor();
      sc.visit(xtreeTest);
    }


    System.out.println("TestOrderBy");
    System.out.println("Table before sort");
    System.out.println(xtabOBTest);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the OrderBy after it was sorted by Column1");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testOuterUnion
 */
  public static void testOuterUnion()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    XATTable xtabITest2 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(10));
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    
    Vector vInputCol3 = new Vector();
    vInputCol3.add(new Integer(10));
    vInputCol3.add(new Integer(15));
    vInputCol3.add(new Integer(6));
    vInputCol3.add(new Integer(5));
    vInputCol3.add(new Integer(4));
    vInputCol3.add(new Integer(11));
    vInputCol3.add(new Integer(2));
    vInputCol3.add(new Integer(9));

    Vector vInputCol5 = new Vector();
    vInputCol5.add(new Integer(10));
    vInputCol5.add(new Integer(7));
    vInputCol5.add(new Integer(6));
    vInputCol5.add(new Integer(5));
    vInputCol5.add(new Integer(4));
    vInputCol5.add(new Integer(11));
    vInputCol5.add(new Integer(2));
    vInputCol5.add(new Integer(9));


    
    xtabITest1.setName("Test1");
    try
    {
		xtabITest1.appendColumn("Column11", vInputCol);
		xtabITest1.appendColumn("Column13", vInputCol3);
		xtabITest1.appendColumn("Column14", vInputCol5);
    }

    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(26));
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(13));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));
    
    Vector vInputCol4 = new Vector();
    vInputCol4.add(new Integer(26));
    vInputCol4.add(new Integer(15));
    vInputCol4.add(new Integer(2));
    vInputCol4.add(new Integer(11));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(34));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(9));
    
    Vector vInputCol6 = new Vector();
    vInputCol6.add(new Integer(26));
    vInputCol6.add(new Integer(15));
    vInputCol6.add(new Integer(2));
    vInputCol6.add(new Integer(11));
    vInputCol6.add(new Integer(9));
    vInputCol6.add(new Integer(34));
    vInputCol6.add(new Integer(9));
    vInputCol6.add(new Integer(4));
    
    xtabITest2.setName("Test2");
    try
    {
      xtabITest2.appendColumn("Column11", vInputCol6);
      xtabITest2.appendColumn("Column13", vInputCol4);
      xtabITest2.appendColumn("Column12", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    OuterUnion ou = new OuterUnionImp(xnRootNode);
    xnRootNode.setOperator(ou);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode2 = xnRootNode.getChild(1);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

	((Source)xLeaves[1].getOperator()).setOutput(xtabITest2);
	((Source)xLeaves[1].getOperator()).setType(Source.TABLE);
    // end setup


    System.out.println("TestOuterUnion");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the OuterUnion");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testProject
 */
  public static void testProject()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabPTest = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    xtabPTest.setName("Greg's Test");
    try
    {
      xtabPTest.appendColumn("Column1", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(3));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(1));
    try
    {
      xtabPTest.appendColumn("Column2", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}



    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    Project p = new ProjectImp(xnRootNode);
    String[] saProjCols = {"Column2"};
    p.setColumnNames(saProjCols);
    xnRootNode.setOperator(p);

    XATNode xnsourceNode = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest = new SourceImp(xnsourceNode);
    xnsourceNode.setOperator(srTest);


    XATNode[] xLeaves = xtreeTest.getLeaves();
    for(int i = 0; i<xLeaves.length; i++)
    {
	((Source)xLeaves[i].getOperator()).setOutput(xtabPTest);
	((Source)xLeaves[i].getOperator()).setType(Source.TABLE);
    }
    // end setup


    System.out.println("TestProject");
    System.out.println("Table before sort");
    System.out.println(xtabPTest);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the Project is run on [Column2]");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testRightOuterJoin
 */
  public static void testRightOuterJoin()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();

    // begin setup

    // make two columns.
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));

    // make first table.
    XATTable xtabITest1 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();

    xtabITest1.setName("Test1");
    try {
        xtabITest1.appendColumn("Column10", vInputCol2);
        xtabITest1.appendColumn("Column11", vInputCol);
        xtabITest1.appendColumn("Column13", vInputCol2);
    } catch (XATTableTupleNoMatchException e) {
    }

    // make the second table. 
    XATTable xtabITest2 = new XATTableImp();
    xtabITest2.setName("Test2");
    try {
        xtabITest2.appendColumn("Column11", vInputCol2);
        xtabITest2.appendColumn("Column12", vInputCol);
        xtabITest2.appendColumn("Column14", vInputCol);
    } catch (XATTableTupleNoMatchException e) {
    }

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    RightOuterJoin roj = new RightOuterJoinImp(xnRootNode, null);
    xnRootNode.setOperator(roj);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try {
        xnsourceNode1 = xnRootNode.getChild(0);
    } catch (XATNodeDoesNotExistException e) {
    }

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);

    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try {
        xnsourceNode2 = xnRootNode.getChild(1);
    } catch (XATNodeDoesNotExistException e) {
    }

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);

    XATNode[] xLeaves = xtreeTest.getLeaves();
    ((Source) xLeaves[0].getOperator()).setOutput(xtabITest1);
    ((Source) xLeaves[0].getOperator()).setType(Source.TEMP);

    ((Source) xLeaves[1].getOperator()).setOutput(xtabITest2);
    ((Source) xLeaves[1].getOperator()).setType(Source.TEMP);
    // end setup

    System.out.println("TestLeftOuterJoin");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println(
        "This is the output of the LeftOuterJoin for Column11=Column12");
    System.out.println(xtreeTest.getRoot().getOperator().getOutputDataSource());
  }
/**
 * testRightSemiJoin
 */
  public static void testRightSemiJoin()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    XATTable xtabITest2 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    xtabITest1.setName("Test1");
    try
    {
      xtabITest1.appendColumn("Column11", vInputCol);
    }

    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));
    xtabITest2.setName("Test2");
    try
    {
      xtabITest2.appendColumn("Column12", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    // create test expressions
    /////
    TerminalExpression expLeft = new  TerminalExpressionImp(new ColumnNameImp("Test1", "Column11"));
    TerminalExpression expRight = new  TerminalExpressionImp(new ColumnNameImp("Test2", "Column12"));

    BinCOMPExpression TestExpression = new BinCOMPExpressionImp(expLeft, expRight);
    TestExpression.setType(BinCOMPExpression.EQ);
    /////

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    RightSemiJoin rsj = new RightSemiJoinImp(xnRootNode, TestExpression);
    xnRootNode.setOperator(rsj);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode2 = xnRootNode.getChild(1);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

	((Source)xLeaves[1].getOperator()).setOutput(xtabITest2);
	((Source)xLeaves[1].getOperator()).setType(Source.TABLE);
    // end setup


    System.out.println("TestRightSemiJoin");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the RightSemiJoin for Column11=Column12");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
  /**
   * testSelect
   */

  public static void testSelect()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabTest = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(3));
    vInputCol.add(new Integer(1));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(5));
    vInputCol.add(new Integer(3));
    vInputCol.add(new Integer(1));
    vInputCol.add(new Integer(89));
    xtabTest.setName("Greg's Test");
    try
    {
      xtabTest.appendColumn("Column1", vInputCol);
    }
    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(1));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(3));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(7));
    try
    {
      xtabTest.appendColumn("Column2", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    // create test expressions
    /////
    TerminalExpression expLeft = new  TerminalExpressionImp(new ColumnNameImp("Greg's Test", "Column1"));
    TerminalExpression expRight = new  TerminalExpressionImp(3);

    BinCOMPExpression TestExpression = new BinCOMPExpressionImp(expLeft, expRight);
    TestExpression.setType(BinCOMPExpression.GEQ);
    /////

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    Select s = new SelectImp(xnRootNode, TestExpression);
    xnRootNode.setOperator(s);

    XATNode xnsourceNode = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest = new SourceImp(xnsourceNode);
    xnsourceNode.setOperator(srTest);


    XATNode[] xLeaves = xtreeTest.getLeaves();
    for(int i = 0; i<xLeaves.length; i++)
    {
	((Source)xLeaves[i].getOperator()).setOutput(xtabTest);
	((Source)xLeaves[i].getOperator()).setType(Source.TABLE);
    }
    // end setup

    System.out.println("TestSelect");
    System.out.println("Table before run");
    System.out.println(xtabTest);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the Select after it was queried to find the items in Column1 >= 3");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());


  }
public static void testSQLStmt() {

    ExecuteVisitor qe = new ExecuteVisitor();
    XATTree xtree = new XATTreeImp();

    // prepare SQL node
    XATNode xnode = new XATNodeImp();

    XATOperator xop =
        new SQLStmtImp(
            xnode,
            "select starplayer_pname_1, starplayer_playerposition_2 from starplayer where iid > 2");

    xnode.setOperator(xop);
    xtree.setRoot(xnode);
    
    // execute the tree
    qe.visit(xtree);

    System.out.println("This is the output of the SQLStmt operator");
    System.out.println(xtree.getRoot().getOperator().getOutput());

}

  /**
   * testThetaJoin
   */
  public static void testThetaJoin()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    XATTable xtabITest2 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    xtabITest1.setName("Test1");
    try
    {
      xtabITest1.appendColumn("Column11", vInputCol);
    }

    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));
    xtabITest2.setName("Test2");
    try
    {
      xtabITest2.appendColumn("Column12", vInputCol2);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    // create test expressions
    /////
    TerminalExpression expLeft = new  TerminalExpressionImp(new ColumnNameImp("Test1", "Column11"));
    TerminalExpression expRight = new  TerminalExpressionImp(new ColumnNameImp("Test2", "Column12"));

    BinCOMPExpression TestExpression = new BinCOMPExpressionImp(expLeft, expRight);
    TestExpression.setType(BinCOMPExpression.EQ);
    /////

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    ThetaJoin tj = new ThetaJoinImp(xnRootNode, TestExpression);
    xnRootNode.setOperator(tj);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode2 = xnRootNode.getChild(1);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

	((Source)xLeaves[1].getOperator()).setOutput(xtabITest2);
	((Source)xLeaves[1].getOperator()).setType(Source.TABLE);
    // end setup


    System.out.println("TestThetaJoin");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the ThetaJoin for Column11=Column12");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testTree
 */
// Test if we can have anything generated by using Justin's code.
public static void testTree(String queryFile) {
    String query = null;
    long timestart = 0,
        timegeneration = 0,
        timepushdown = 0,
        timedecorrelation = 0,
        timeschema = 0,
        timeend = 0;
    XATTree tree = null;

    try {
        timestart = System.currentTimeMillis();
        //reads a query from a file and translates it
        //into a string
        query = readQuery(queryFile);
        QuiltParser parser = new QuiltParser();
        QuiltQuery q = null;

        //System.out.println("**********Starting Query Parsing***********");
        q = parser.parseQuery(query);
        //System.out.println("**********Starting tree generation***********");
        ParserTraverse pt = new ParserTraverse();
        /*************  Step 1: Generate the Tree **************/
        pt.visit(q);

        tree = pt.getTree();
        //use this for printing the tree
        Debugger debug = new Debugger(tree);
        if (DEBUG)
            debug.printTree();

        timegeneration = System.currentTimeMillis();

        /*************  Step 2: Decorrelate the Tree **************/

        System.out.println("**********Starting Query Decorrelation************");
        QueryDecorrelation qd1 = new QueryDecorrelation(tree);
        tree = qd1.getDecorTree();
        if (DEBUG)
            debug.printTree();

        timedecorrelation = System.currentTimeMillis();

        /*************  Step 5: Compute The Schema **************/
        //         System.out.println("**********Starting Schema Computation************");

        //        SchemaComputer sc = new SchemaComputer();
        //        sc.compute(tree);

        if (pushdown) {
            /*************  Step 3: Pushdown the Tree **************/
            //going to link that tree with the rewrite class
            //first create a vector of the rule classes to look at
            Vector classList = new Vector();
            String s1 =
                new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ReWriteNavigateRules");
            String s1a =
                new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ReWriteRenameRules");
            String s2 =
                new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ReWriteSelectRules");
            classList.addElement(s1);
            classList.addElement(s1a);
            classList.addElement(s2);

            //instantiate the rules class
            ReWriteRules rules = new ReWriteRules(classList);

            //now make the order of rules to look at
            Vector order = new Vector();
            order.addElement(
                "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavigateImp");
            order.addElement(
                "edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.NameColumnImp");
            order.addElement(
                "edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.SelectImp");
            //set the variable table in the rules class to be the hashtable from PT
            rules.setVariableTable(pt.getTree().getBindingTable());

            //create the traversal strategy
            ReWriteTraversal traverse = new ReWriteTraversal(tree, rules, order);

            System.out.println("**********Starting pushDown************");
            traverse.doPushdown(traverse.DOWN);
            if (DEBUG)
                debug.printTree();

        }
        timepushdown = System.currentTimeMillis();
        if (withSchema) {
            System.out.println("Starting Schema Cleanup");
            SchemaCleanupVisitor sc = new SchemaCleanupVisitor();
            sc.visit(tree);
            System.out.println("After schema cleanup");
            if (DEBUG)
                debug.printTree();
        }

        timeschema = System.currentTimeMillis();

        /*************  Step 6: Execute The Query **************/
        System.out.println("**********Starting Query Execution ************");

        /***** Try the execut visitor **/
        ExecuteVisitor execTest = new ExecuteVisitor();
        if(DEBUG)
        	System.setProperty("DEBUG_ExecuteVisitor", "OK");
        execTest.visit(tree);
        timeend = System.currentTimeMillis();
        System.out.println("end executing query");

        XATTable table = (XATTable)tree.getRoot().getOperator().getOutputDataSource();
        if (table.getNumberOfTuples() > 0) {
            if (DEBUG) {
                System.out.println("This is the output of the query");
                System.out.println("it is the text of an XML file");
                System.out.println(table.getValue(table.getNumberOfColumns(), 1));
            }
        } else {
            System.out.println("Output is empty!");
        }
    } catch (Exception e) {
        e.printStackTrace(System.out);
    }

    System.out.println(
        "EXP:Time for generation: " + (timegeneration - timestart) + " ms");
    System.out.println(
        "EXP:Time for decorrelation: " + (timedecorrelation - timegeneration) + " ms");
    System.out.println(
        "EXP:Time for pushdown: " + (timepushdown - timedecorrelation) + " ms");
    System.out.println(
        "EXP:Time for schema cleanup: " + (timeschema - timepushdown) + " ms");
    System.out.println("EXP:Time for execution: " + (timeend - timeschema) + " ms");
    System.out.println("EXP:Total time: " + (timeend - timestart) + " ms");

    System.out.println();

    System.out.println("EXP:Nodes cut: " + SchemaCleanupStatistics.nodesCut);

    int nodes = SchemaCleanupStatistics.filteredNodes.size();

    int columns = 0;

    for (Iterator i = SchemaCleanupStatistics.filteredNodes.iterator();
        i.hasNext();
        ) {
        Object o = i.next();
        if (o instanceof XATOperatorImp) {
            columns += ((XATOperatorImp) o).getColumnsFiltered();
        }
    }
    System.out.println("EXP:Nodes filtered: " + nodes);
    System.out.println("EXP:Columns filtered: " + columns);
    if (nodes > 0) {
        System.out.println(
            "EXP:Average columns filtered per node: " + (((double) columns) / nodes));
    }

    StatisticsGatheringVisitor sgv = new StatisticsGatheringVisitor();

    sgv.visit(tree);
    sgv.visitTempTrees();

    nodes = sgv.getNumberOfNodes();
    columns = sgv.getNumberOfSavedColumns();

    System.out.println();
    System.out.println("EXP:Nodes: " + nodes);
    System.out.println("EXP:Columns saved: " + columns);
    System.out.println(
        "EXP:Average columns saved per node: " + (((double) columns) / nodes));

}
/**
 * testTree
 */
// Test if we can have anything generated by using Justin's code.
public static void testTree(String queryUserFile, String queryViewFile) {
    String query = null;
    long timestart = 0,
        timegeneration = 0,
        timepushdown = 0,
        timeschema = 0,
        timeend = 0;
    XATTree tree = null;

    try {
        timestart = System.currentTimeMillis();

        //reads a query from a file and translates it
        //into a string
        query = readQuery(queryUserFile);
        QuiltParser parser = new QuiltParser();
        QuiltQuery q = null;

        //System.out.println("**********Starting Query Parsing***********");
        q = parser.parseQuery(query);
        //System.out.println("**********Starting tree generation***********");
        ParserTraverse pt = new ParserTraverse();
        /*************  Step 1: Generate the user Tree **************/
        pt.visit(q);

        tree = pt.getTree();
        //use this for printing the tree
        System.out.println("********** User XAT *********");
        Debugger debug = new Debugger(tree);
        if (DEBUG)
            debug.printTree();

        /*************  Step 2: Decorrelate the Tree **************/
        //        if (decorrelate)
        //        {
        System.out.println("**********Starting Query Decorrelation************");
        QueryDecorrelation qd1 = new QueryDecorrelation(tree);
        tree = qd1.getDecorTree();
        System.out.println("********** Decorrelated User XAT *********");
        debug.setTree(tree);
        if (DEBUG)
            debug.printTree();
        //        }

        /** View Query **/
        //reads a query from a file and translates it
        //into a string
        String queryView = readQuery(queryViewFile);
        QuiltParser parserV = new QuiltParser();
        QuiltQuery qv = null;

        //System.out.println("**********Starting Query Parsing***********");
        qv = parser.parseQuery(queryView);
        //System.out.println("**********Starting tree generation***********");
        ParserTraverse ptv = new ParserTraverse();
        /*************  Step 1: Generate the Tree **************/
        ptv.visit(qv);

        XATTree treeV = ptv.getTree();
        //use this for printing the tree
        System.out.println("**************** View XAT ******************");
        debug = new Debugger(treeV);
        if (DEBUG)
            debug.printTree();

        /*************  Step 2: Decorrelate the Tree **************/
        //if (decorrelate)
        //{
        System.out.println("**********Starting Query Decorrelation************");
        QueryDecorrelation qdV = new QueryDecorrelation(treeV);
        treeV = qdV.getDecorTree();
        System.out.println("**************** Decorrelated View XAT ******************");
        debug.setTree(treeV);
        if (DEBUG)
            debug.printTree();
        //}

        //Merge

        MergeVisitor mergeV = new MergeVisitor(tree, treeV);
        mergeV.mergeTrees();
        BindingTable newUserTable = tree.getBindingTable();
            

        System.out.println("******************** Merged Tree *******************");
        debug = new Debugger(tree);
        if (DEBUG)
            debug.printTree();

        timegeneration = System.currentTimeMillis();

        if (pushdown) {
            System.out.println("Begin Pushdown");

            /*************  Step 3: Pushdown the Tree **************/
            //going to link that tree with the rewrite class
            //first create a vector of the rule classes to look at
            Vector classList = new Vector();
            String s1 =
                new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ReWriteNavigateRules");
            String s1a =
                new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ReWriteRenameRules");
            String s2 =
                new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ReWriteSelectRules");
            classList.addElement(s1);
            classList.addElement(s1a);
            classList.addElement(s2);

            //instantiate the rules class
            ReWriteRules rules = new ReWriteRules(classList);

            //now make the order of rules to look at
            Vector order = new Vector();
            order.addElement(
                "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavigateImp");
            order.addElement(
                "edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.NameColumnImp");
            order.addElement(
                "edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.SelectImp");
            //set the variable table in the rules class to be the hashtable from PT
            rules.setVariableTable(newUserTable);

            //create the traversal strategy
            ReWriteTraversal traverse = new ReWriteTraversal(tree, rules, order);

            System.out.println("**********Starting pushDown************");
            traverse.doPushdown(traverse.DOWN);
            if (DEBUG)
                debug.printTree();

        }

        timepushdown = System.currentTimeMillis();

        /*************  Step 5: Compute The Schema **************/
        //         System.out.println("**********Starting Schema Computation************");

        //        SchemaComputer sc = new SchemaComputer();
        //        sc.compute(tree);

        if (withSchema) {
            System.out.println("Starting Schema Cleanup");
            SchemaCleanupVisitor sc = new SchemaCleanupVisitor();
            sc.visit(tree);
            System.out.println("After schema cleanup");
            if (DEBUG)
                debug.printTree();
        }

        timeschema = System.currentTimeMillis();

        /*************  Step 6: Execute The Query **************/
        System.out.println("**********Starting Query Execution ************");

        /***** Try the execut visitor **/
        System.out.println("start executing query");
        ExecuteVisitor execTest = new ExecuteVisitor();
        if(DEBUG)
        	System.setProperty("DEBUG_ExecuteVisitor", "OK");
        execTest.visit(tree);
        timeend = System.currentTimeMillis();
        System.out.println("end executing query");

        XATTable table = (XATTable)tree.getRoot().getOperator().getOutputDataSource();
        if (table != null) {
            if (table.getNumberOfTuples() > 0) {
                /*
                System.out.println("This is the output of the query");
                System.out.println("it is the text of an XML file");
                System.out.println(table.getCell(table.getNumberOfColumns(), 1));
                */
            } else {
                System.out.println("Output is empty!");
            }
        } else {
            System.out.println("Output is empty!");
        }
    } catch (Exception e) {
        e.printStackTrace(System.out);
    }
    System.out.println(
        "EXP:Time for generation: " + (timegeneration - timestart) + " ms");
    System.out.println(
        "EXP:Time for pushdown: " + (timepushdown - timegeneration) + " ms");
    System.out.println(
        "EXP:Time for schema cleanup: " + (timeschema - timepushdown) + " ms");
    System.out.println("EXP:Time for execution: " + (timeend - timeschema) + " ms");
    System.out.println("EXP:Total time: " + (timeend - timestart) + " ms");

    System.out.println();

    System.out.println("EXP:Nodes cut: " + SchemaCleanupStatistics.nodesCut);

    int nodes = SchemaCleanupStatistics.filteredNodes.size();

    int columns = 0;

    for (Iterator i = SchemaCleanupStatistics.filteredNodes.iterator();
        i.hasNext();
        ) {
        Object o = i.next();
        if (o instanceof XATOperatorImp) {
            columns += ((XATOperatorImp) o).getColumnsFiltered();
        }
    }
    System.out.println("EXP:Nodes filtered: " + nodes);
    System.out.println("EXP:Columns filtered: " + columns);
    if (nodes > 0) {
        System.out.println(
            "EXP:Average columns filtered per node: " + (((double) columns) / nodes));
    }

    StatisticsGatheringVisitor sgv = new StatisticsGatheringVisitor();

    sgv.visit(tree);
    sgv.visitTempTrees();

    nodes = sgv.getNumberOfNodes();
    columns = sgv.getNumberOfSavedColumns();

    System.out.println();
    System.out.println("EXP:Nodes: " + nodes);
    System.out.println("EXP:Columns saved: " + columns);
    System.out.println(
        "EXP:Average columns saved per node: " + (((double) columns) / nodes));

}
/**
 * testUnion
 */
  public static void testUnion()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    XATTable xtabITest2 = new XATTableImp();
    XATTree xtreeTest = new XATTreeImp();
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(15));
	vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    
    Vector vInputCol3 = new Vector();
    vInputCol3.add(new Integer(7));
	vInputCol3.add(new Integer(7));
	vInputCol3.add(new Integer(6));
    vInputCol3.add(new Integer(5));
    vInputCol3.add(new Integer(4));
    vInputCol3.add(new Integer(11));
    vInputCol3.add(new Integer(2));
    vInputCol3.add(new Integer(9));
    xtabITest1.setName("Test1");
    try
    {
      xtabITest1.appendColumn("Column11", vInputCol);
		xtabITest1.appendColumn("Column12", vInputCol3);
      }

    catch (XATTableTupleNoMatchException e)
    {}
    Vector vInputCol2 = new Vector();
    vInputCol2.add(new Integer(15));
    vInputCol2.add(new Integer(7));
    vInputCol2.add(new Integer(6));
    vInputCol2.add(new Integer(5));
    vInputCol2.add(new Integer(4));
    vInputCol2.add(new Integer(11));
    vInputCol2.add(new Integer(2));
    vInputCol2.add(new Integer(9));

    Vector vInputCol4 = new Vector();
    vInputCol4.add(new Integer(7));
    vInputCol4.add(new Integer(15));
    vInputCol4.add(new Integer(2));
    vInputCol4.add(new Integer(11));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(34));
    vInputCol4.add(new Integer(9));
    vInputCol4.add(new Integer(4));
    
    xtabITest2.setName("Test2");
    try
    {
      xtabITest2.appendColumn("Column11", vInputCol2);
      xtabITest2.appendColumn("Column12", vInputCol4);
    }
    catch (XATTableTupleNoMatchException e)
    {}

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    Union u = new UnionImp(xnRootNode);
    xnRootNode.setOperator(u);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode xnsourceNode2 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode2 = xnRootNode.getChild(1);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest2 = new SourceImp(xnsourceNode2);
    xnsourceNode2.setOperator(srTest2);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

	((Source)xLeaves[1].getOperator()).setOutput(xtabITest2);
	((Source)xLeaves[1].getOperator()).setType(Source.TABLE);
    // end setup


    System.out.println("TestUnion");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("Table2 before sort");
    System.out.println(xtabITest2);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the Union");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testXMLDifference
 */
  public static void testXMLDifference()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    
    XATTree xtreeTest = new XATTreeImp();
	Vector cellVector = new Vector();
	cellVector.add(new Integer(10));
	cellVector.add(new Integer(11));
	
	Vector cellVectorB = new Vector();
	cellVectorB.add(new Integer(11));
	cellVectorB.add(new Integer(11));

	Vector cellVectorC = new Vector();
	cellVectorC.add(new Integer(12));
	cellVectorC.add(new Integer(12));
	
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(10));
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(cellVector);
    vInputCol.add(cellVectorB);
    vInputCol.add(cellVectorB);
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
        
  	Vector cellVectorA = new Vector();
	cellVectorA.add(new Integer(11));
	cellVectorA.add(new Integer(10));
	
	Vector vInputCol3 = new Vector();
    vInputCol3.add(new Integer(10));
    vInputCol3.add(new Integer(15));
    vInputCol3.add(new Integer(6));
    vInputCol3.add(new Integer(5));
    vInputCol3.add(cellVectorA);
    vInputCol3.add(cellVector);
    vInputCol3.add(cellVectorC);
    vInputCol3.add(new Integer(2));
    vInputCol3.add(new Integer(9));

    
    xtabITest1.setName("Test1");
    try
    {
		xtabITest1.appendColumn("Column11", vInputCol);
		xtabITest1.appendColumn("Column13", vInputCol3);
    }

    catch (XATTableTupleNoMatchException e)
    {}

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    XMLDifference ou = new XMLDifferenceImp(xnRootNode);
    ou.setOutputColumnName("newXMLDifferenceCol");
    xnRootNode.setOperator(ou);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

    // end setup


    System.out.println("TestXMLDifference");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the XMLDifference");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
  /**
   * testXMLExpose
   */
  // tests the Expose operator to show that it is working
  // also shows that the Source Operator works with XML files
  public static void testXMLExpose(String sXMLFile)
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    //  Setup for the test of the XML reading and writing
    System.out.println("Creating tree");
    XATTree xtrSourceExpose = new XATTreeImp();

    // setting the root node
    xtrSourceExpose.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtrSourceExpose.getRoot();
    String sName = "$s";
    Expose expTest = new ExposeImp(xnRootNode);
    expTest.setColumnName(sName);
    xnRootNode.setOperator(expTest);

    // adding first child
    xtrSourceExpose.addNode(new XATNodeImp(),xtrSourceExpose.getRoot());
    try
    {
      XATNode xnSourceNode = xtrSourceExpose.getRoot().getChild(0);
      String sLocation = sXMLFile;
      Source sRcTest = new SourceImp(xnSourceNode,sLocation,Source.XML);
      xnSourceNode.setOperator(sRcTest);
      sRcTest.setOutputColumnName("$s");
    }
    catch (XATNodeDoesNotExistException e42)
    {}
//  end Source-Expose Setup



    System.out.println("TestExpose");
    System.out.println("begin executing Operators");
    execTest.visit(xtrSourceExpose);
    System.out.println("end executing Operators");

    System.out.println("This is the output of the Expose Operator");
    System.out.println("it is the text of an XML file");
    System.out.println(expTest.getOutput());

  }
/**
 * testXMLIntersection
 */
  public static void testXMLIntersection()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    
    XATTree xtreeTest = new XATTreeImp();
	Vector cellVector = new Vector();
	cellVector.add(new Integer(10));
	cellVector.add(new Integer(11));
	
	Vector cellVectorB = new Vector();
	cellVectorB.add(new Integer(11));
	cellVectorB.add(new Integer(11));
    
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(10));
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(cellVector);
    vInputCol.add(cellVectorB);
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    
    Vector vInputCol3 = new Vector();

  	Vector cellVectorA = new Vector();
	cellVectorA.add(new Integer(11));
	cellVectorA.add(new Integer(10));


	
    vInputCol3.add(new Integer(10));
    vInputCol3.add(new Integer(15));
    vInputCol3.add(new Integer(6));
    vInputCol3.add(new Integer(5));
    vInputCol3.add(cellVectorA);
    vInputCol3.add(cellVector);
    vInputCol3.add(new Integer(2));
    vInputCol3.add(new Integer(9));

    
    xtabITest1.setName("Test1");
    try
    {
		xtabITest1.appendColumn("Column11", vInputCol);
		xtabITest1.appendColumn("Column13", vInputCol3);
    }

    catch (XATTableTupleNoMatchException e)
    {}

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    XMLIntersection ou = new XMLIntersectionImp(xnRootNode);
    ou.setOutputColumnName("newXMLIntersectionCol");
    xnRootNode.setOperator(ou);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

    // end setup


    System.out.println("TestXMLIntersection");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the XMLIntersection");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
/**
 * testOuterUnion
 */
  public static void testXMLUnion()
  {
    ExecuteVisitor execTest = new ExecuteVisitor();
    // begin setup
    XATTable xtabITest1 = new XATTableImp();
    
    XATTree xtreeTest = new XATTreeImp();
	Vector cellVector = new Vector();
	cellVector.add(new Integer(10));
	cellVector.add(new Integer(11));
    
    Vector vInputCol = new Vector();
    vInputCol.add(new Integer(10));
    vInputCol.add(new Integer(15));
    vInputCol.add(new Integer(2));
    vInputCol.add(new Integer(11));
    vInputCol.add(cellVector);
    vInputCol.add(new Integer(34));
    vInputCol.add(new Integer(9));
    vInputCol.add(new Integer(4));
    
    Vector vInputCol3 = new Vector();
    vInputCol3.add(new Integer(10));
    vInputCol3.add(new Integer(15));
    vInputCol3.add(new Integer(6));
    vInputCol3.add(new Integer(5));
    vInputCol3.add(new Integer(4));
    vInputCol3.add(new Integer(11));
    vInputCol3.add(new Integer(2));
    vInputCol3.add(new Integer(9));

    Vector vInputCol5 = new Vector();
    vInputCol5.add(new Integer(10));
    vInputCol5.add(new Integer(7));
    vInputCol5.add(new Integer(6));
    vInputCol5.add(new Integer(5));
    vInputCol5.add(new Integer(4));
    vInputCol5.add(new Integer(11));
    vInputCol5.add(new Integer(2));
    vInputCol5.add(new Integer(9));


    
    xtabITest1.setName("Test1");
    try
    {
		xtabITest1.appendColumn("Column11", vInputCol);
		xtabITest1.appendColumn("Column13", vInputCol3);
		xtabITest1.appendColumn("Column14", vInputCol5);
    }

    catch (XATTableTupleNoMatchException e)
    {}

    xtreeTest.setRoot(new XATNodeImp());
    XATNode xnRootNode = xtreeTest.getRoot();
    XMLUnion ou = new XMLUnionImp(xnRootNode);
    ou.setOutputColumnName("newXMLUnionCol");
    xnRootNode.setOperator(ou);

    XATNode xnsourceNode1 = new XATNodeImp();
    xtreeTest.addNode(new XATNodeImp(), xnRootNode);
    try
    {
      xnsourceNode1 = xnRootNode.getChild(0);
    }
    catch (XATNodeDoesNotExistException e)
    {}

    Source srTest1 = new SourceImp(xnsourceNode1);
    xnsourceNode1.setOperator(srTest1);


    XATNode[] xLeaves = xtreeTest.getLeaves();
	((Source)xLeaves[0].getOperator()).setOutput(xtabITest1);
	((Source)xLeaves[0].getOperator()).setType(Source.TABLE);

    // end setup


    System.out.println("TestXMLUnion");
    System.out.println("Table1 before sort");
    System.out.println(xtabITest1);
    System.out.println("begin executing Operator");
    execTest.visit(xtreeTest);
    System.out.println("end executing Operator");

    System.out.println("This is the output of the XMLUnion");
    System.out.println(xtreeTest.getRoot().getOperator().getOutput());
  }
}
